##################################################################################
##                                                                              ##
##  This file is part of the buola project (https://code.google.com/p/buola/).  ##
##                                                                              ##
##  Copyright(c) 2007-2012 Xavi Gratal                                          ##
##  gratal AT gmail DOT com                                                     ##
##                                                                              ##
##  Buola is free software: you can redistribute it and/or modify               ##
##  it under the terms of the GNU General Public License as published by        ##
##  the Free Software Foundation, either version 3 of the License, or           ##
##  (at your option) any later version.                                         ##
##                                                                              ##
##  Buola is distributed in the hope that it will be useful,                    ##
##  but WITHOUT ANY WARRANTY; without even the implied warranty of              ##
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ##
##  GNU General Public License for more details.                                ##
##                                                                              ##
##  You should have received a copy of the GNU General Public License           ##
##  along with buola.  If not, see <http://www.gnu.org/licenses/>.              ##
##                                                                              ##
##################################################################################

set(BUOLA_PLATFORM_MAC 0)
set(BUOLA_PLATFORM_LINUX 0)
set(BUOLA_PLATFORM_WINDOWS 0)

if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    set(BUOLA_PLATFORM_MAC 1)
elseif(CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(BUOLA_PLATFORM_LINUX 1)
elseif(CMAKE_SYSTEM_NAME STREQUAL "Windows")
    set(BUOLA_PLATFORM_WINDOWS 1)
else()
    message(FATAL_ERROR "unsupported platform ${CMAKE_SYSTEM_NAME}")
endif()

set(BUOLA_COMPILER_CLANG 0)
set(BUOLA_COMPILER_GCC 0)
set(BUOLA_COMPILER_INTEL 0)

if(CMAKE_CXX_COMPILER_ID STREQUAL Clang)
    set(BUOLA_COMPILER_CLANG 1)
elseif(CMAKE_CXX_COMPILER_ID STREQUAL GNU)
    set(BUOLA_COMPILER_GCC 1)
elseif(CMAKE_CXX_COMPILER_ID STREQUAL Intel)
    set(BUOLA_COMPILER_INTEL 1)
else()
    message(FATAL_ERROR "unsupported compiler ${CMAKE_CXX_COMPILER_ID}")
endif()
