//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2013 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_AUTO_FORWARD_H_
#define _BUOLA_AUTO_FORWARD_H_

#include <buola/auto/intrusive_ptr.h>

///global namespace for buola

///\todo update forward declarations
namespace buola {

//types in app
class CApp;
class CCmdLine;
class CCmdLineFlag;
class CEventLoop;
class CFinishFunction;
class CInitFunction;
class CMessageQueue;
class CPlugin;
class CTimer;

//types in datetime
class CDate;
class CDateTime;
class CTimeOfDay;
class CTimeZone;

//types in io
class CFDListener;
class CFDPoller;
class CPipe;
class CSocket;

//types in os
class CEnv;
class CProcess;

//types in threads
class CSimpleThread;
class CThreadManager;

//types in utility
struct triggered_event;
class CDesktopFile;
class UValue;
class UAny;

//types in xml
class CXMLDoc;
class CXMLElement;
class CXMLNode;

namespace tty
{
    class CScreen;
    class CLineReader;
}

namespace os
{
    class CApplication;
    class CAppMenu;
    class CAppAction;
    class CFileAction;
    class CMIMEType;
    class CIconTheme;
    class CUser;
    class CGroup;
    typedef intrusive_ptr<CFileAction> PFileAction;
}

namespace io
{
    class CFile;
    class CURI;
    class CFolder;
    class CFileImpl;
    class CURIScheme;
    class CFileFilter;
    class CResourceFinder;
    typedef intrusive_ptr<CFileFilter> PFileFilter;
}

/*namespace buola*/ }

#endif
