///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_CONTAINER_CSIMPLEBUFFER_H_
#define _BUOLA_CONTAINER_CSIMPLEBUFFER_H_

#include <buola/buola.h>
#include <buola/container/detail/cbufferstorage.h>

namespace buola {

template<typename tType,std::size_t vCapacity,typename tAlloc=std::allocator<tType> >
class CSimpleBuffer : private detail::CBufferStorage<tType,vCapacity,tAlloc>
{
    typedef detail::CBufferStorage<tType,vCapacity,tAlloc> tStorage;

public:
    /// default constructor

    /// Initializes the buffer to be empty
    CSimpleBuffer()
    {}

    /// constructor

    /// \p pCapacity specifies the size for dynamic buffers. This function is not valid for non-dynamic buffers.
    ///
    /// Initializes the buffer to be empty
    CSimpleBuffer(std::size_t pCapacity)
        :   tStorage(pCapacity)
    {}

    using tStorage::GetCapacity;
    using tStorage::GetMaxCapacity;

    /// returns a pointer to the data
    tType *GetData()    {   return tStorage::GetStorage();   }

    /// returns a pointer to the data
    tType *begin()    {   return tStorage::GetStorage();   }

    /// returns a pointer to the data
    tType *end()    {   return tStorage::GetStorage()+GetCapacity();   }
};

/*namespace buola*/ }

#endif
