///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_CONTAINER_DETAIL_CSIZEHOLDER_H_
#define _BUOLA_CONTAINER_DETAIL_CSIZEHOLDER_H_

#include <buola/buola.h>

namespace buola { namespace detail {

template<bool vHold,typename tSize>
struct CSizeHolder
{
    tSize GetSize() const       {   return 0;   }
    void SetSize(tSize)         {}
    void IncrementSize()        {}
    void IncrementSize(tSize)   {}
    void DecrementSize()        {}
    void DecrementSize(tSize)   {}
};

template<typename tSize>
struct CSizeHolder<true,tSize>
{
    tSize GetSize() const           {   return mSize;   }
    void SetSize(tSize pSize)       {   mSize=pSize; }
    void IncrementSize()            {   ++mSize;    }
    void IncrementSize(tSize pInc)  {   mSize+=pInc;    }
    void DecrementSize()            {   --mSize;    }
    void DecrementSize(tSize pInc)  {   mSize-=pInc;    }

private:
    tSize mSize;
};

/*namespace detail*/ } /*namespace buola*/ }

#endif
