//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_DATETIME_CHRONO_H_
#define _BUOLA_DATETIME_CHRONO_H_

#if BUOLA_COMPILER_CLANG
#include <boost/chrono.hpp>
#else
#include <chrono>
#endif

namespace buola {

#if BUOLA_COMPILER_CLANG
namespace chrono=boost::chrono;
#else
namespace chrono=std::chrono;
#endif

inline chrono::seconds operator"" _s(unsigned long long pMS)
{
    return chrono::seconds(pMS);
}

inline chrono::milliseconds operator"" _ms(unsigned long long pMS)
{
    return chrono::milliseconds(pMS);
}

inline chrono::microseconds operator"" _us(unsigned long long pMS)
{
    return chrono::microseconds(pMS);
}

inline chrono::nanoseconds operator"" _ns(unsigned long long pMS)
{
    return chrono::nanoseconds(pMS);
}

/*namespace buola*/ }

#endif
