///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_MAT_DETAIL_ASSIGN_H_
#define _BUOLA_MAT_DETAIL_ASSIGN_H_

#include <buola/mat/detail/traits.h>

namespace buola { namespace mat { namespace detail {

template<typename tScalar,typename tDst,typename tSrc>
inline OEnableIf<QElementAccess<tSrc>,void> assign(tDst &pDst,const tSrc &pSrc)
{
    int lRows=pDst.Rows();
    int lCols=pDst.Cols();
    for(int r=0;r<lRows;r++)
        for(int c=0;c<lCols;c++)
            pDst.template At<tScalar&>(r,c)=pSrc.template At<tScalar>(r,c);
};

template<typename tScalar,typename tDst,typename tSrc>
inline OEnableIfNot<QElementAccess<tSrc>,void> assign(tDst &pDst,const tSrc &pSrc)
{
    pSrc.EvalTo(pDst);
};

template<typename tScalar,typename tDst,typename tSrc>
inline OEnableIf<QElementAccess<tSrc>,void> assign(const tDst &pDst,const tSrc &pSrc)
{
    int lRows=pDst.Rows();
    int lCols=pDst.Cols();
    for(int r=0;r<lRows;r++)
        for(int c=0;c<lCols;c++)
            pDst.template At<tScalar&>(r,c)=pSrc.template At<tScalar>(r,c);
};

template<typename tScalar,typename tDst,typename tSrc>
inline OEnableIfNot<QElementAccess<tSrc>,void> assign(const tDst &pDst,const tSrc &pSrc)
{
    pSrc.EvalTo(pDst);
};

/*namespace detail*/ } /*namespace mat*/ } /*namespace buola*/ }

#endif
