///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_MAT_DETAIL_CEXPRESSIONOP_H_
#define _BUOLA_MAT_DETAIL_CEXPRESSIONOP_H_

#include <buola/buola.h>

namespace buola { namespace mat { namespace detail {

//tSub is a fully-qualified type
template<typename tSub,typename tTag>
class CExpressionOp
{
    static_assert(QIsReference<tSub>::value,"template argument to expression operator must be a reference");
    
public:
    CExpressionOp(tSub pSub)
        :   mSub(pSub)
    {}

    CExpressionOp(const CExpressionOp&)=delete;
    CExpressionOp& operator=(const CExpressionOp&)=delete;

    tSub Sub() const {   return mSub;    }
    
private:
    tSub mSub;
};

struct GStarOp {};
struct GColwiseOp {};
struct GRowwiseOp {};

template<typename tSub>
using CStarOp=CExpressionOp<tSub,GStarOp>;

template<typename tSub>
using CColwiseOp=CExpressionOp<tSub,GColwiseOp>;

template<typename tSub>
using CRowwiseOp=CExpressionOp<tSub,GRowwiseOp>;

/*namespace detail*/ } /*namespace mat*/ } /*namespace buola*/ }

#endif
