///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_MAT_DETAIL_CNAMEOP_H_
#define _BUOLA_MAT_DETAIL_CNAMEOP_H_

#include <buola/buola.h>

namespace buola { namespace mat { namespace detail {

//tSub is a fully-qualified type
template<typename tSub>
class CNameOp
{
    static_assert(QIsReference<tSub>::value,"template argument to CNameOp must be a reference");

public:
    CNameOp(tSub pSub,const std::wstring &pName)
        :   mSub(pSub)
        ,   mName(pName)
    {}

    CNameOp(const CNameOp&)=delete;
    CNameOp& operator=(const CNameOp&)=delete;

    tSub Sub() const {   return mSub;    }
    const std::wstring &Name() const  {   return mName;   }

private:
    tSub mSub;
    std::wstring mName;
};

/*namespace detail*/ } /*namespace mat*/ } /*namespace buola*/ }

#endif
