///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_MAT_DETAIL_CROWEXTENSION_H_
#define _BUOLA_MAT_DETAIL_CROWEXTENSION_H_

#include <buola/mat/cexpr.h>

namespace buola { namespace mat { namespace detail {

template<typename tSub>
struct MMatrixTraits<CRowExtension<tSub>>
{
private:
    typedef MMatrixTraits<ODecay<tSub>> TSubTraits;

public:
    typedef typename TSubTraits::TScalar TScalar;
    static const size_t cRows=TSubTraits::cRows;
    static const size_t cCols=cDynamic;///\todo:change it to unknown
    static const bool cRowLinearAccess=false;
    static const bool cColLinearAccess=TSubTraits::cColLinearAccess;
    static const bool cRowPacketAccess=false;
    static const bool cColPacketAccess=TSubTraits::cColPacketAccess;
    static const bool cMightAlias=false;
    static const bool cElementAccess=TSubTraits::cElementAccess;
    static const bool cEigenMappable=false;
    static const bool cKeepConstness=false;
    static const bool cExprAssignable=false;
    static const bool cIsMatrix=false;
};

template<typename tSub>
class CRowExtension : public CExpr<CRowExtension<tSub>>
{
    typedef MMatrixTraits<CRowExtension<tSub>> TSelfTraits;

public:
    CRowExtension(tSub pSub)
        :   mSub(pSub)
    {}

    CRowExtension(const CRowExtension&)=delete;
    CRowExtension& operator=(const CRowExtension&)=delete;

    size_t Rows() const  {   return mSub.Rows(); }

    template<typename tType>
    tType At(size_t r,size_t c) const       {   return mSub.template At<tType>(r);    }
    
private:
    tSub mSub;
};

/*namespace detail*/ } /*namespace mat*/ } /*namespace buola*/ }

#endif
