///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_MAT_EIGEN_H_
#define _BUOLA_MAT_EIGEN_H_

#include <buola/mat.h>
#include <buola/mat/detail/eigen_wrapper.h>

#include <Eigen/Eigenvalues>

namespace buola { namespace mat {

template<typename tDerived>
std::pair<CVec<detail::OScalar<tDerived>>,CMat<detail::OScalar<tDerived>>> eigen_vectors(const CExpr<tDerived> &pExpr)
{
    assert(pExpr.Cols()==pExpr.Rows());
    CVec<detail::OScalar<tDerived>> lAResult(pExpr.Derived().Cols());
    CMat<detail::OScalar<tDerived>> lVResult(pExpr.Derived().Cols(),pExpr.Derived().Rows());
    
    Eigen::SelfAdjointEigenSolver<detail::OEigenMatrixType<decltype(detail::eigen_mappable(pExpr.Derived()))>> lSolver(detail::eigen_map(detail::eigen_mappable(pExpr.Derived())));
    
    detail::eigen_map(lAResult)=lSolver.eigenvalues();
    detail::eigen_map(lVResult)=lSolver.eigenvectors();
    
    return {std::move(lAResult),std::move(lVResult)};
}

/*namespace mat*/ } /*namespace buola*/ }

#endif
