///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_MAT_GAMMA_H_
#define _BUOLA_MAT_GAMMA_H_

#include <buola/mat/cexpr.h>
#include <buola/mat/detail/celementunaryop.h>
#include <buola/functors/transform/math.h>
#include <boost/math/special_functions/digamma.hpp>

namespace buola { namespace mat {

template<typename tScalar>
OEnableIf<QIsNumeric<tScalar>,tScalar> digamma(tScalar pScalar)
{
    return boost::math::digamma(pScalar);
}
    
template<typename tScalar>
OEnableIf<QIsNumeric<tScalar>,tScalar> lgamma(tScalar pScalar)
{
    ///\todo check why it doesn't work to use lgamma
    return ::lgamma(pScalar);
}
    
namespace detail {

    struct ADigamma : public fn::GUnaryTransform
    {
        template<typename tParam>
        tParam operator()(const tParam &pVal) const
        {
            return digamma(pVal);
        }
    };
    
    struct ALgamma : public fn::GUnaryTransform
    {
        template<typename tParam>
        tParam operator()(const tParam &pVal) const
        {
            return lgamma(pVal);
        }
    };
    
/*namespace detail*/ }

template<typename tLH>
detail::CElementUnaryOp<const tLH&,detail::ADigamma>
digamma(const CExpr<tLH> &pLH)
{
    return {pLH.Derived(),{}};
}

template<typename tLH>
detail::CElementUnaryOp<const tLH&,detail::ALgamma>
lgamma(const CExpr<tLH> &pLH)
{
    return {pLH.Derived(),{}};
}

/*namespace mat*/ } /*namespace buola*/ }

#endif
