///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_MAT_JOIN_H_
#define _BUOLA_MAT_JOIN_H_

#include <buola/mat/cexpr.h>
#include <buola/mat/detail/chjoin.h>
#include <buola/mat/detail/cvjoin.h>

namespace buola { namespace mat {

///\todo see if it is better to make these functions inline
    
template<typename tLH,typename tRH>
detail::CHJoin<const tLH&,const tRH&> operator>>(const CExpr<tLH> &pLH,const CExpr<tRH> &pRH)
{
    return {pLH.Derived(),pRH.Derived()};
}
    
template<typename tLH,typename tRH>
detail::CVJoin<const tLH&,const tRH&> operator&(const CExpr<tLH> &pLH,const CExpr<tRH> &pRH)
{
    return {pLH.Derived(),pRH.Derived()};
}

template<typename tLH,typename tRH>
detail::CHJoin<const tLH&,const tRH&> hjoin(const CExpr<tLH> &pLH,const CExpr<tRH> &pRH)
{
    return {pLH.Derived(),pRH.Derived()};
}

template<typename tLH,typename tRH>
detail::CVJoin<const tLH&,const tRH&> vjoin(const CExpr<tLH> &pLH,const CExpr<tRH> &pRH)
{
    return {pLH.Derived(),pRH.Derived()};
}

template<typename tLH>
detail::CHJoin<const tLH&,CScalar<detail::OScalar<tLH>>> hjoin(const CExpr<tLH> &pLH,const detail::OScalar<tLH> &pRH)
{
    return {pLH.Derived(),CScalar<detail::OScalar<tLH>>{pRH}};
}

template<typename tLH>
detail::CVJoin<const tLH&,CScalar<detail::OScalar<tLH>>> vjoin(const CExpr<tLH> &pLH,const detail::OScalar<tLH> &pRH)
{
    return {pLH.Derived(),CScalar<detail::OScalar<tLH>>{pRH}};
}

/*namespace mat*/ } /*namespace buola*/ }

#endif
