///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_MAT_PRETTYPRINT_H_
#define _BUOLA_MAT_PRETTYPRINT_H_

#include <buola/mat/cexpr.h>
#include <buola/io/formatters.h>

namespace buola { namespace mat {

template<typename tChar,typename tSub>
inline std::basic_ostream<tChar>& operator<<(std::basic_ostream<tChar> &pStream,const detail::CNameOp<tSub> &pExpr)
{
    const auto &lSub=element_accessible(pExpr.Sub());

    int lPreWidth=pExpr.Name().length()+3;
    std::string lPre(lPreWidth,' ');
    int lNumWidth=1+7*lSub.Cols();
    std::string lNum(lNumWidth,' ');

    pStream << lPre << "\u250C" << lNum << "\u2510\n";

    for(int i=0;i<lSub.Rows();i++)
    {
        if(i==lSub.Rows()/2)
            pStream << pExpr.Name() << " = ";
        else
            pStream << lPre;
        pStream << "\u2502";
        for(int j=0;j<lSub.Cols();j++)
        {
            pStream << " " << FDouble(lSub(i,j),6);
        }
        pStream << " \u2502";
        pStream << "\n";
    }

    pStream << lPre << "\u2514" << lNum << "\u2518\n";

    return pStream;
}

/*namespace mat*/ } /*namespace buola*/ }

#endif
