///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_TRAITS_POINTER_H_
#define _BUOLA_TRAITS_POINTER_H_

#include <buola/buola.h>
#include <type_traits>

namespace buola {

template<typename tParam,typename tEnabler=void>
struct MRemovePointer
{
    typedef typename std::remove_pointer<tParam>::type type;
};

template<typename tParam>
struct MRemovePointer<tParam,typename std::conditional<true,void,typename tParam::element_type>::type>
{
    typedef typename tParam::element_type type;
};

template<typename tParam>
struct MPointerToReference
{
    typedef typename std::add_lvalue_reference<typename MRemovePointer<tParam>::type>::type type;
};

/*namespace buola*/ }

#endif
