///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_UTILITY_UEVENT_H_
#define _BUOLA_UTILITY_UEVENT_H_

#include <buola/buola.h>

namespace buola {

template<class tPointer,std::size_t vNumBits>
class UPointerPlusBits;

template<class tType,std::size_t vNumBits>
class UPointerPlusBits<tType*,vNumBits>
{
    static const std::size_t cMask=(std::size_t(1)<<vNumBits)-1;

public:
    tType *GetPointer() const       {   return (tType*)(mData&~cMask);          }
    void SetPointer(tType *pPtr)    {   mData=std::size_t(pPtr)|(mData&cMask);  }
    std::size_t GetBits() const     {   return mData&cMask;                     }
    void SetBits(std::size_t pBits) {   mData=(mData&~cMask)|pBits;             }

    void SetPointerAndBits(tType *pPtr,std::size_t pBits)   {   mData=std::size_t(pPtr)|pBits;  }

private:
    std::size_t mData;
};

/*namespace buola*/ }

#endif
