//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_UTILITY_UUID_H_
#define _BUOLA_UTILITY_UUID_H_

#include <buola/buola.h>
#include <buola/utility/random.h>

namespace buola {

/// \addtogroup utility
///@{

///returns a universally unique identifier

///it uses the random version defined in RFC 4122
inline std::string get_uuid()
{
    uint8_t lData[16];

    random::fill(lData,lData+16);

    //set variant
    lData[8]&=0xbf;
    lData[8]|=0x80;
    //set version
    lData[6]&=0x4f;
    lData[6]|=0x40;

    std::string lReturn=hex_string(lData,4);
    lReturn+='-';
    lReturn+=hex_string(lData+4,2);
    lReturn+='-';
    lReturn+=hex_string(lData+6,2);
    lReturn+='-';
    lReturn+=hex_string(lData+8,2);
    lReturn+='-';
    lReturn+=hex_string(lData+10,6);
    return lReturn;
}

///@}

/*namespace buola*/ }

#endif
