///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_ZZ_IF_H_
#define _BUOLA_ZZ_IF_H_

#include <buola/zz/zbase.h>

namespace buola { namespace zz {

template<typename tFunc,bool vTrue>
class ZIf : public ZBase<ZIf<tFunc,vTrue>>
{
public:
    template<typename tIt>
    struct tAttribute
    {
        typedef UUnused tType;
    };

    explicit ZIf(const tFunc &pFunc)
        :   mFunc(pFunc)
    {}

    explicit ZIf(tFunc &&pFunc)
        :   mFunc(std::move(pFunc))
    {}

    ZIf(const ZIf &pRH)
        :   mFunc(pRH.mFunc)
    {}

    ZIf(ZIf &&pRH)
        :   mFunc(std::move(pRH.mFunc))
    {}

    template<typename tIt,typename tAttr,typename tCtx,typename tSk>
    bool Parse(tIt &pB,const tIt &pE,tAttr &pAttr,tCtx&,const tSk &pSk) const
    {
        skip_over(pB,pE,pSk);

        if(pB==pE) return false;

        if(mFunc(*pB)==vTrue)
        {
            pAttr=*pB;
            ++pB;
            return true;
        }

        return false;
    }

private:
    tFunc mFunc;
};

template<typename tFunc>
ZIf<ODecay<tFunc>,true> if_true(tFunc &&pFunc)
{
    return ZIf<ODecay<tFunc>,true>(std::forward<tFunc>(pFunc));
}

template<typename tFunc>
ZIf<ODecay<tFunc>,false> if_false(tFunc &&pFunc)
{
    return ZIf<ODecay<tFunc>,false>(std::forward<tFunc>(pFunc));
}

/*namespace zz*/ } /*namespace buola*/ }

#endif
