///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_ZZ_REPEAT_H_
#define _BUOLA_ZZ_REPEAT_H_

#include <buola/zz/zbase.h>
#include <buola/zz/detail/vector.h>

namespace buola { namespace zz {

template<typename tA,std::size_t vCount>
class ZFixedRepeatOp : public ZBase<ZFixedRepeatOp<tA,vCount>>
{
public:
    template<typename tIt>
    struct tAttribute
    {
        typedef typename detail::MArrayType<typename tA::template tAttribute<tIt>::tType,vCount>::type tType;
    };

    ZFixedRepeatOp(const ZFixedRepeatOp &pRH)
        :   mA(pRH.mA)
    {}
    
    ZFixedRepeatOp(ZFixedRepeatOp &&pRH)
        :   mA(std::move(pRH.mA))
    {}
    
    template<typename tPA>
    explicit ZFixedRepeatOp(tPA &&pA)
        :   mA(std::forward<tPA>(pA))
    {}
    
    template<typename tIt,typename tAttr,typename tCtx,typename tSk>
    bool Parse(tIt &pB,const tIt &pE,tAttr &pAttr,tCtx &pCtx,const tSk &pSk) const
    {
        tIt lI=pB;
        for(int i=0;i<vCount;i++)
        {
            if(!mA.Parse(lI,pE,detail::get_array_element(pAttr,i),pCtx,pSk))
                return false;
        }
        pB=lI;
        return true;
    }
private:    
    tA mA;
};

template<std::size_t vCount,typename tA>
ZFixedRepeatOp<ODecay<tA>,vCount> repeat(tA &&pA)
{
    return ZFixedRepeatOp<ODecay<tA>,vCount>(std::forward<tA>(pA));
}

/*namespace zz*/ } /*namespace buola*/ }

#endif
