///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_ZZ_UTILITY_H_
#define _BUOLA_ZZ_UTILITY_H_

#include <buola/zz.h>

namespace buola { namespace zz {

namespace detail {
  
    template<typename t1,typename t2>
    struct CVectorTie
    {
        CVectorTie(std::vector<t1> &p1,std::vector<t2> &p2)
            :   m1(p1)
            ,   m2(p2)
        {}

        void clear()
        {
            m1.clear();
            m2.clear();
        }
        
        void push_back(std::pair<t1,t2> &&pAttr)
        {
            m1.emplace_back(std::move(pAttr.first));
            m2.emplace_back(std::move(pAttr.second));
        }
        
        std::vector<t1> &m1;
        std::vector<t2> &m2;
    };
    
    template<typename tSub,typename tIt,typename t1,typename t2>
    struct MVectorElementType<tSub,tIt,CVectorTie<t1,t2>>
    {
        typedef std::pair<t1,t2> type;
    };
    
/*namespace detail*/ }

template<typename t1,typename t2>
detail::CVectorTie<t1,t2> tie_vector(std::vector<t1> &p1,std::vector<t2> &p2)
{
    return {p1,p2};
}

/*namespace zz*/ } /*namespace buola*/ }

#endif
