///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_ZZ_ZATTR_H_
#define _BUOLA_ZZ_ZATTR_H_

#include <buola/zz/zbase.h>

namespace buola { namespace zz {

template<typename tAttrType>
class ZAttr : public ZBase<ZAttr<tAttrType>>
{
public:
    template<typename tIt>
    struct tAttribute
    {
        typedef tAttrType tType;
    };
    
    ZAttr(const tAttrType &pAttr)
        :   mAttr(pAttr)
    {}
    
    ZAttr(tAttrType &&pAttr)
        :   mAttr(std::move(pAttr))
    {}
    
    ZAttr(const ZAttr &pRH)
        :   mAttr(pRH.mAttr)
    {}
    
    ZAttr(ZAttr &&pRH)
        :   mAttr(std::move(pRH.mAttr))
    {}
    
    template<typename tIt,typename tAttr,typename tCtx,typename tSk>
    bool Parse(tIt& /*pB*/,const tIt& /*pE*/,tAttr &pAttr,tCtx&,const tSk&) const
    {
        pAttr=mAttr;
        return true;
    }

private:
    tAttrType mAttr;
};

template<typename tAttrType>
ZAttr<ODecay<tAttrType>> attr(tAttrType &&pAttr)
{
    return ZAttr<ODecay<tAttrType>>(std::forward<tAttrType>(pAttr));
}

/*namespace zz*/ } /*namespace buola*/ }

#endif
