///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_ZZ_ZRAW_H_
#define _BUOLA_ZZ_ZRAW_H_

#include <buola/zz/zbase.h>

namespace buola { namespace zz {

template<typename tA>
class ZRaw : public ZBase<ZRaw<tA>>
{
public:
    template<typename tIt>
    struct tAttribute
    {
        typedef std::pair<tIt,tIt> tType;
    };

    ZRaw(const ZRaw &pRH)
        :   mA(pRH.mA)
    {}
    
    ZRaw(ZRaw &pRH)
        :   mA(pRH.mA)
    {}
    
    ZRaw(ZRaw &&pRH)
        :   mA(std::move(pRH.mA))
    {}
    
    template<typename tPA>
    explicit ZRaw(tPA &&pA)
        :   mA(std::forward<tPA>(pA))
    {}
    
    template<typename tIt,typename tAttr,typename tCtx,typename tSk>
    bool Parse(tIt &pB,const tIt &pE,tAttr &pAttr,tCtx &pCtx,const tSk &pSk) const
    {
        tIt lB=pB;
        UUnused lDummy;
        if(!mA.Parse(pB,pE,lDummy,pCtx,pSk)) return false;
        pAttr=std::make_pair(lB,pB);
        return true;
    }
private:    
    tA mA;
};

template<typename tA>
ZRaw<ODecay<tA>> raw(tA&& pA)
{
    return ZRaw<ODecay<tA>>(std::forward<tA>(pA));
}

/*namespace zz*/ } /*namespace buola*/ }

#endif
