///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_ZZ_ZRAWRULE_H_
#define _BUOLA_ZZ_ZRAWRULE_H_

#include <buola/zz/zrule.h>

namespace buola { namespace zz {

template<typename tIt,typename tSk=UUnused>
class ZRawRule : public ZRule<tIt,UUnused,tSk>
{
public:
    typedef ZRule<tIt,UUnused,tSk> tRuleBase;
    
    template<typename tIter>
    struct tAttribute
    {
        typedef std::pair<tIter,tIter> tType;
    };
    
    ZRawRule()
    {}
    
    ZRawRule(const ZRawRule &pRH)
        :   tRuleBase((const tRuleBase&)pRH) //we muse make sure that the copy constructor is used
    {}
    
    template<typename tExpr>
    explicit ZRawRule(const tExpr &pExpr)
        :   tRuleBase(pExpr)
    {}
    
    template<typename tUnusedCtx,typename tPAttr>
    bool Parse(tIt &pB,const tIt &pE,tPAttr &pAttr,tUnusedCtx &pCtx,const tSk &pSk) const
    {
        tIt lB=pB;
        UUnused lDummy;
        if(!tRuleBase::Parse(pB,pE,lDummy,pCtx,pSk))
            return false;
        
        pAttr=std::make_pair(lB,pB);
        
        return true;
    }
    
    template<typename tExpr>
    ZRawRule &operator%=(tExpr &&pExpr)
    {
        tRuleBase::operator%=(std::forward<tExpr>(pExpr));
        return *this;
    }
    
    template<typename tExpr>
    ZRawRule &operator=(tExpr &&pExpr)
    {
        tRuleBase::operator=(std::forward<tExpr>(pExpr));
        return *this;
    }
};

/*namespace zz*/ } /*namespace buola*/ }

#endif
