///\todo upgrade

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//  This file is part of the buola project (https://code.google.com/p/buola/).  //
//                                                                              //
//  Copyright(c) 2007-2012 Xavi Gratal                                          //
//  gratal AT gmail DOT com                                                     //
//                                                                              //
//  Buola is free software: you can redistribute it and/or modify               //
//  it under the terms of the GNU General Public License as published by        //
//  the Free Software Foundation, either version 3 of the License, or           //
//  (at your option) any later version.                                         //
//                                                                              //
//  Buola is distributed in the hope that it will be useful,                    //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with buola.  If not, see <http://www.gnu.org/licenses/>.              //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef _BUOLA_ZZ_ZSKIPPING_H_
#define _BUOLA_ZZ_ZSKIPPING_H_

#include <buola/zz/zbase.h>
#include <buola/zz/detail/cskipdisabler.h>

namespace buola { namespace zz {

template<typename tSk,typename tA>
class ZSkipping : public ZBase<ZSkipping<tSk,tA>>
{
public:
    template<typename tIt>
    struct tAttribute
    {
        typedef typename tA::template tAttribute<tIt>::tType tType;
    };

    ZSkipping(const ZSkipping &pRH)
        :   mSk(pRH.mSk)
        ,   mA(pRH.mA)
    {}
    
    ZSkipping(ZSkipping &&pRH)
        :   mSk(std::move(pRH.mSk))
        ,   mA(std::move(pRH.mA))
    {}
    
    template<typename tPSk,typename tPA>
    explicit ZSkipping(tPSk &&pSk,tPA &&pA)
        :   mSk(std::forward<tPSk>(pSk))
        ,   mA(std::forward<tPA>(pA))
    {}
    
    template<typename tIt,typename tAttr,typename tCtx,typename tSkUnused>
    bool Parse(tIt &pB,const tIt &pE,tAttr &pAttr,tCtx &pCtx,const tSkUnused&) const
    {
        return mA.Parse(pB,pE,pAttr,pCtx,mSk);
    }
private:    
    tSk mSk;
    tA mA;
};

template<typename tSk,typename tA>
ZSkipping<ODecay<tSk>,ODecay<tA>> skipping(tSk &&pSk,tA&& pA)
{
    return ZSkipping<ODecay<tSk>,ODecay<tA>>(std::forward<tSk>(pSk),std::forward<tA>(pA));
}

/*namespace zz*/ } /*namespace buola*/ }

#endif
